/*
 * $Id: heap7.c,v 1.1 2004/06/02 12:15:03 raptor Exp $
 *
 * heap7.c - vulnerable code by qitest1 <qitest1@bespin.org>
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * See http://www.thc.org/root/docs/exploit_writing/heap_off_by_one.txt
 */

#include <signal.h>

void sigsegvhandler()
{
	printf("Caught SIGSEGV.\n");

	exit(1);
}

void do_it(char *s0, char *s1)
{
	char	*p0, *p1;
	int	*size_p, len0, len1;

	len0 = strlen(s0);
	printf("len0: %u\n", len0);
	len1 = strlen(s1);
	printf("len1: %u\n", len1);

	p0 = (char *) malloc(len0);
	p1 = (char *) malloc(len1);
	printf("p0 -> %p\n", p0);
	printf("p1 -> %p\n", p1);

	size_p = (int *) p0 - 1;
	printf("allocated size for p0: %u (%p)\n", *size_p, *size_p);
	size_p = (int *) p1 - 1;
	printf("allocated size for p1: %u (%p)\n", *size_p, *size_p);

	p0[0] = 0x00;
	strncat(p0, s0, len0);
	memcpy(p1, s1, len1);

	size_p = (int *) p0 - 1;
	printf("allocated size for p0: %u (%p)\n", *size_p, *size_p);
	size_p = (int *) p1 - 1;
	printf("allocated size for p1: %u (%p)\n", *size_p, *size_p);

	free(p1);

	return;
}

int main(int argc, char *argv[])
{
	char	s1[1024];

	signal(SIGSEGV, sigsegvhandler);

	snprintf(s1, sizeof(s1), "Your input is: %s\n", argv[2]);

	do_it(argv[1], s1);

	exit(0);
}
