/*
 * $Id: heap8.c,v 1.1 2004/06/02 12:15:03 raptor Exp $
 *
 * heap8.c - vulnerable code by qitest1 <qitest1@bespin.org>
 * Copyright (c) 2004 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * See http://www.thc.org/root/docs/exploit_writing/heap_off_by_one.txt
 */

#include <signal.h>

void sigsegvhandler()
{
	printf("Caught SIGSEGV.\n");

	exit(1);
}

void do_it(char *s)
{
	char	*p0, *p1;
	int	*size_p, len;

	len = strlen(s);
	printf("len: %u\n", len);

	p0 = (char *) malloc(len);
	p1 = (char *) malloc(8);
	printf("p0 -> %p\n", p0);
	printf("p1 -> %p\n", p1);

	size_p = (int *) p0 - 1;
	printf("allocated size for p0: %u (%p)\n", *size_p, *size_p);
	size_p = (int *) p1 - 1;
	printf("allocated size for p1: %u (%p)\n", *size_p, *size_p);

	p0[0] = 0x00;
	strncat(p0, s, len);

	size_p = (int *) p0 - 1;
	printf("allocated size for p0: %u (%p)\n", *size_p, *size_p);
	size_p = (int *) p1 - 1;
	printf("allocated size for p1: %u (%p)\n", *size_p, *size_p);

	free(p1);

	return;
}

int main(int argc, char *argv[])
{
	signal(SIGSEGV, sigsegvhandler);

	printf("argv[1] is at %p\n", argv[1]);

	do_it(argv[1]);

	exit(0);
}
